zipios::CollectionCollection Class Reference

CollectionCollection is a FileCollection that consists of an arbitrary number of FileCollections. More...

`#include <collcoll.h>`

Inheritance diagram for zipios::CollectionCollection:
[legend]

## Public Member Functions

| CollectionCollection ()
| Constructor.
| CollectionCollection (const CollectionCollection &src)
| Copy constructor.
const CollectionCollection & | operator= (const CollectionCollection &src)
| Copy assignment operator.
bool | addCollection (const FileCollection &collection)
| Adds a collection.
bool | addCollection (FileCollection *collection)
| Adds the collection pointed to by collection.
virtual void | close ()
| Closes the FileCollection.
virtual ConstEntries | entries () const
| Returns a vector of const pointers to the entries in the FileCollection.
virtual ConstEntryPointer | getEntry (const string &name, MatchPath matchpath=MATCH) const
| Returns a ConstEntryPointer to a FileEntry object for the entry with the specified name.
virtual istream * | getInputStream (const ConstEntryPointer &entry)
| Returns a pointer to an opened istream for the specified FileEntry.
virtual istream * | getInputStream (const string &entry_name, MatchPath matchpath=MATCH)
| Returns a pointer to an opened istream for the specified entry name.
virtual int | size () const
| Returns the number in entries in all collections kept by the CollectionCollection object.
virtual FileCollection * | clone () const
| Create a heap allocated clone of the object this method is called for.
Public Member Functions inherited from zipios::FileCollection
| FileCollection ()
| FileCollection constructor.
| FileCollection (const FileCollection &src)
| Copy constructor.
const FileCollection & | operator= (const FileCollection &src)
| Copy assignment operator.
virtual string | getName () const
| Returns the name of the FileCollection.
bool | isValid () const
| The member function returns true if the collection is valid.
virtual | ~FileCollection ()
| FileCollection destructor.

## Static Public Member Functions

static CollectionCollection & | inst ()
| This static method provides a singleton instance of a CollectionCollection.

## Protected Member Functions

void | getEntry (const string &name, ConstEntryPointer &cep, std::vector< FileCollection * >::const_iterator &it, MatchPath matchpath=MATCH) const
| A protected getEntry member function, that not only finds an entry that match the name, if such an entry exists in the collection, it also returns, which collection it was found in.

## Protected Attributes

vector< FileCollection * > | _collections
Protected Attributes inherited from zipios::FileCollection
string | _filename
Entries | _entries
bool | _valid

## Additional Inherited Members

Public Types inherited from zipios::FileCollection
enum | MatchPath { IGNORE , MATCH }

## Detailed Description

CollectionCollection is a FileCollection that consists of an arbitrary number of FileCollections.

With a CollectionCollection the user can use multiple FileCollections transparently, making it easy for a program to keep some of its files in a zip archive and others stored in ordinary files. CollectionCollection can be used to create a simple virtual filesystem, where all collections are mounted in /. If more than one collection contain a file with the same path only the one in the first added collection will be accessible.

Definition at line 26 of file collcoll.h.

## Constructor & Destructor Documentation

## CollectionCollection() [1/2]

zipios::CollectionCollection::CollectionCollection | ( |  | ) |

explicit

Constructor.

Definition at line 16 of file collcoll.cpp.

## CollectionCollection() [2/2]

zipios::CollectionCollection::CollectionCollection | ( | const CollectionCollection & | src | ) |

inline

Copy constructor.

Definition at line 118 of file collcoll.h.

## ~CollectionCollection()

zipios::CollectionCollection::~CollectionCollection | ( |  | ) |

virtual

Definition at line 112 of file collcoll.cpp.

## Member Function Documentation

## addCollection() [1/2]

bool zipios::CollectionCollection::addCollection | ( | const FileCollection & | collection | ) |

Adds a collection.

Parameters

  collection | The collection to add.

Returns
  true if the collection was added succesfully and the added collection is valid.

Definition at line 21 of file collcoll.cpp.

## addCollection() [2/2]

bool zipios::CollectionCollection::addCollection | ( | FileCollection * | collection | ) |

Adds the collection pointed to by collection.

The CollectionCollection will call delete on the pointer when it is destructed, so the caller should make absolutely sure to only pass in a collection created with new and be sure to leave it alone after adding it. If the collection is not added false is returned and the caller remains responsible for the collection pointed to by collection.

Parameters

  collection | A pointer to the collection to add.

Returns
  true if the collection was added succesfully and the added collection is valid.

Definition at line 31 of file collcoll.cpp.

## clone()

FileCollection * zipios::CollectionCollection::clone | ( |  | ) | const

virtual

Create a heap allocated clone of the object this method is called for.

The caller is responsible for deallocating the clone when he is done with it.

Returns
  A heap allocated copy of the object this method is called for.

Implements zipios::FileCollection.

Definition at line 108 of file collcoll.cpp.

## close()

void zipios::CollectionCollection::close | ( |  | ) |

virtual

Closes the FileCollection.

Implements zipios::FileCollection.

Definition at line 41 of file collcoll.cpp.

## entries()

ConstEntries zipios::CollectionCollection::entries | ( |  | ) | const

virtual

Returns a vector of const pointers to the entries in the FileCollection.

Returns
  a ConstEntries containing the entries of the FileCollection.

Exceptions

  InvalidStateException | Thrown if the collection is invalid.

Reimplemented from zipios::FileCollection.

Definition at line 46 of file collcoll.cpp.

## getEntry() [1/2]

void zipios::CollectionCollection::getEntry | ( | const string & | name,
|  | ConstEntryPointer & | cep,
|  | std::vector< FileCollection * >::const_iterator & | it,
|  | MatchPath | matchpath = MATCH ) const

protected

A protected getEntry member function, that not only finds an entry that match the name, if such an entry exists in the collection, it also returns, which collection it was found in.

Definition at line 123 of file collcoll.cpp.

## getEntry() [2/2]

ConstEntryPointer zipios::CollectionCollection::getEntry | ( | const string & | name,
|  | MatchPath | matchpath = MATCH ) const

virtual

Returns a ConstEntryPointer to a FileEntry object for the entry with the specified name.

To ignore the path part of the filename in search of a match, specify FileCollection::IGNORE as the second argument.

Parameters

  name | A string containing the name of the entry to get.
  matchpath | Speficy MATCH, if the path should match as well, specify IGNORE, if the path should be ignored.

Returns
  A ConstEntryPointer to the found entry. The returned pointer equals zero if no entry is found.

Exceptions

  InvalidStateException | Thrown if the collection is invalid.

Reimplemented from zipios::FileCollection.

Definition at line 58 of file collcoll.cpp.

## getInputStream() [1/2]

istream * zipios::CollectionCollection::getInputStream | ( | const ConstEntryPointer & | entry | ) |

virtual

Returns a pointer to an opened istream for the specified FileEntry.

It is the callers responsibility to delete the stream when he is done with it. Returns 0, if there is no such FileEntry in the FileCollection.

Parameters

  entry | A ConstEntryPointer to the FileEntry to get an istream to.

Returns
  an open istream for the specified entry. The istream is allocated on heap and it is the users responsibility to delete it when he is done with it.

Exceptions

  InvalidStateException | Thrown if the collection is invalid.

Implements zipios::FileCollection.

Definition at line 72 of file collcoll.cpp.

## getInputStream() [2/2]

istream * zipios::CollectionCollection::getInputStream | ( | const string & | entry_name,
|  | MatchPath | matchpath = MATCH )

virtual

Returns a pointer to an opened istream for the specified entry name.

It is the callers responsibility to delete the stream when he is done with it. Returns 0, if there is no entry with the specified name in the FileCollection.

Parameters

  matchpath | Speficy MATCH, if the path should match as well, specify IGNORE, if the path should be ignored.

Returns
  an open istream for the specified entry. The istream is allocated on heap and it is the users responsibility to delete it when he is done with it.

Exceptions

  InvalidStateException | Thrown if the collection is invalid.

Implements zipios::FileCollection.

Definition at line 80 of file collcoll.cpp.

## inst()

CollectionCollection & zipios::CollectionCollection::inst | ( |  | ) |

inline static

This static method provides a singleton instance of a CollectionCollection.

The instance is instantiated the first time the method is called.

Returns
  A pointer to a singleton CollectionCollection instance.

Definition at line 111 of file collcoll.h.

## operator=()

const CollectionCollection & zipios::CollectionCollection::operator= | ( | const CollectionCollection & | src | ) |

inline

Copy assignment operator.

Definition at line 129 of file collcoll.h.

## size()

int zipios::CollectionCollection::size | ( |  | ) | const

virtual

Returns the number in entries in all collections kept by the CollectionCollection object.

Reimplemented from zipios::FileCollection.

Definition at line 98 of file collcoll.cpp.

## Member Data Documentation

## _collections

vector< FileCollection * > zipios::CollectionCollection::_collections

protected

Definition at line 95 of file collcoll.h.

The documentation for this class was generated from the following files:

- collcoll.h
- collcoll.cpp